package ru.dbotthepony.mc.prng;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.RandomSource;
import net.minecraft.world.RandomSequence;
import net.minecraft.world.level.levelgen.RandomSupport;
import net.minecraft.world.level.levelgen.XoroshiroRandomSource;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Optional;

public final class BetterRandomSequence extends RandomSequence {
	private static final XoroshiroRandomSource DUMMY = new XoroshiroRandomSource(0, 0);

	public final GJRAND64RandomSource actualRandom;

	public BetterRandomSequence(GJRAND64RandomSource random) {
		super(DUMMY);
		this.actualRandom = random;
	}

	public BetterRandomSequence(long seed, @Nullable ResourceLocation location) {
		this(seed, Optional.ofNullable(location));
	}

	public BetterRandomSequence(long seed, Optional<ResourceLocation> location) {
		super(DUMMY);
		RandomSupport.Seed128bit mixSeed = RandomSupport.upgradeSeedTo128bitUnmixed(seed);

		if (location.isPresent())
			mixSeed = mixSeed.xor(seedForKey(location.get()));

		actualRandom = new GJRAND64RandomSource(mixSeed.mixed());
	}

	@Override
	public @NotNull RandomSource random() {
		return actualRandom;
	}
}
